\ "write-mif" for writing an Altera memory initialization file
\ and "write-coe" for writing a Xilinx memory initialization file

\ current MIF file
0 value file

\ write a line to the file
: write ( addr u -- )
    file write-line drop
;

\ write the first 0x800 words of the virtual machine RAM to the MIF file
: write-mif
    s" ram.mif" r/w create-file drop to file
    s" WIDTH=16;" write
    s" DEPTH=2048;" write
    s" ADDRESS_RADIX=HEX;" write
    s" DATA_RADIX=HEX;" write
    s" CONTENT BEGIN" write
    800 0 do
        i 3 hex-padded file write-file drop
        s"  : " file write-file drop
        i vm-@ 4 hex-padded file write-file drop
        s" ;" write
    loop
    s" END;" write
    file close-file drop
;

\ write the first 0x800 words of the virtual machine RAM to the COE file
: write-coe
    s" ram-content.coe" r/w create-file drop to file
	s" memory_initialization_radix=16;" write
	s" memory_initialization_vector=" write
    800 0 do
        i vm-@ 4 hex-padded file write-file drop
        i 7ff = if s" ;" else s" ," then write
    loop
    file close-file drop
;
