\ common virtual machine definition for the target system

\ opcodes
-1 constant bits:
: opcode: begin over -1 <> while or repeat nip constant ;

0 3 lshift constant m-q2a
1 3 lshift constant m-a2data
2 3 lshift constant m-a2address
3 3 lshift constant m-pc2address
4 3 lshift constant m-pc2data
5 3 lshift constant m-a2pc
6 3 lshift constant m-branch
7 3 lshift constant m-q2pc
8 3 lshift constant m-and
9 3 lshift constant m-or
a 3 lshift constant m-xor
b 3 lshift constant m-plus
c 3 lshift constant m-lshift
d 3 lshift constant m-rshift
e 3 lshift constant m-pop
f 3 lshift constant m-popr
1 2 lshift constant m-wren
0 constant m-nop
1 constant m-no-push
2 constant m-push
3 constant m-pushr

: m2 7 lshift ;

\     [------first microcode------]  [---------second microcode----------]
bits: m-pop               m-no-push  m-a2address m2 m-wren m2 m-pushr   m2  opcode: cmd->r
bits: m-popr              m-no-push  m-a2address m2 m-wren m2 m-push    m2  opcode: cmd-r>
bits: m-pop               m-no-push  m-q2a       m2           m-no-push m2  opcode: cmd->a
bits: m-a2data     m-wren m-push     m-a2address m2           m-nop     m2  opcode: cmd-a>
bits: m-pop               m-no-push  m-a2address m2 m-wren m2 m-no-push m2  opcode: cmd-a!
bits: m-a2address         m-no-push  m-a2address m2 m-wren m2 m-push    m2  opcode: cmd-a@
bits: m-pc2data    m-wren m-pushr    m-a2pc      m2           m-no-push m2  opcode: cmd-call-a
bits: m-pc2address        m-no-push  m-a2address m2 m-wren m2 m-push    m2  opcode: cmd-literal
bits: m-pc2address        m-no-push  m-q2a       m2           m-no-push m2  opcode: cmd-literal-a
bits: m-pop               m-no-push  m-and       m2 m-wren m2 m-push    m2  opcode: cmd-and
bits: m-pop               m-no-push  m-or        m2 m-wren m2 m-push    m2  opcode: cmd-or
bits: m-pop               m-no-push  m-xor       m2 m-wren m2 m-push    m2  opcode: cmd-xor
bits: m-pop               m-no-push  m-plus      m2 m-wren m2 m-push    m2  opcode: cmd-plus
bits: m-pop               m-no-push  m-branch    m2           m-no-push m2  opcode: cmd-branch-a
bits: m-pc2address        m-no-push  m-q2pc      m2           m-no-push m2  opcode: cmd-jump-literal
bits: m-a2pc              m-no-push  m-a2address m2           m-no-push m2  opcode: cmd-jump-a
bits: m-popr              m-no-push  m-q2pc      m2           m-no-push m2  opcode: cmd-return

\ the RAM of the simulated CPU
create ram 20000 allot
ram 20000 0 fill

\ convert a virtual machine RAM address to a host RAM address in the vm RAM memory array
: ram-address ( virtual-address -- physical-address )
    ffff and 2* ram +
;

\ store a word (16 bit) in memory
: w! ( word address -- )
    >r dup ff and r@ c! 8 rshift ff and r> char+ c!
;

\ load a word (16 bit) from memory
: w@ ( address -- word )
    dup c@ swap char+ c@ 8 lshift or
;
    
\ store a word to vm RAM
: vm-! ( word virtual-address -- )
    ram-address w!
;

\ fetch a word from vm RAM
: vm-@ ( virtual-address -- word )
    ram-address w@
;

\ debugging ports
ffff constant led-port
fffe constant keyboard-port

\ vm here pointer
0 value vm-here

\ allocate memory in the vm RAM
: vm-allot ( number -- )
    vm-here + to vm-here
;

\ store a cell in the vm RAM
: vm-, ( cell -- )
    vm-here vm-! 1 vm-allot
;

\ set vm-here pointer
: org ( virtual-address -- )
    to vm-here
;

\ data stack and return stack size
8 constant stack-size
8 constant stackr-size

