--------------------------------------------------------------------------------
-- Copyright (c) 1995-2003 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 9.1.03i
--  \   \         Application : ISE
--  /   /         Filename : test.vhw
-- /___/   /\     Timestamp : Wed Jun 27 16:16:45 2007
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: 
--Design Name: test
--Device: Xilinx
--

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
library work;
use work.ALL;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE STD.TEXTIO.ALL;

ENTITY test IS
END test;

ARCHITECTURE testbench_arch OF test IS
    FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";

    COMPONENT spartan3e_test
        PORT (
            CLK_50MHZ : In std_logic;
            led : Out std_logic_vector (7 DownTo 0);
            btn_east : In std_logic;
            btn_north : In std_logic;
            btn_south : In std_logic;
            btn_west : In std_logic
        );
    END COMPONENT;

    SIGNAL CLK_50MHZ : std_logic := '0';
    SIGNAL led : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL btn_east : std_logic := '0';
    SIGNAL btn_north : std_logic := '0';
    SIGNAL btn_south : std_logic := '0';
    SIGNAL btn_west : std_logic := '0';

    constant PERIOD : time := 40 ns;
    constant DUTY_CYCLE : real := 0.5;
    constant OFFSET : time := 100 ns;

    BEGIN
        UUT : spartan3e_test
        PORT MAP (
            CLK_50MHZ => CLK_50MHZ,
            led => led,
            btn_east => btn_east,
            btn_north => btn_north,
            btn_south => btn_south,
            btn_west => btn_west
        );

        PROCESS    -- clock process for CLK_50MHZ
        BEGIN
            WAIT for OFFSET;
            CLOCK_LOOP : LOOP
                CLK_50MHZ <= '0';
                WAIT FOR (PERIOD - (PERIOD * DUTY_CYCLE));
                CLK_50MHZ <= '1';
                WAIT FOR (PERIOD * DUTY_CYCLE);
            END LOOP CLOCK_LOOP;
        END PROCESS;

        PROCESS
            BEGIN
                -- -------------  Current Time:  105ns
                WAIT FOR 105 ns;
                btn_south <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  145ns
                WAIT FOR 40 ns;
                btn_south <= '0';
                -- -------------------------------------
                WAIT FOR 895 ns;

            END PROCESS;

    END testbench_arch;

